/*$Id: mg_in.cc,v 26.5 2006/11/05 07:19:10 al Exp $ -*- C++ -*-
 * Copyright (C) 2001 Albert Davis
 * Author: Albert Davis <aldavis@ieee.org>
 *
 * This file is part of "Gnucap", the Gnu Circuit Analysis Package
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
//testing=script 2006.10.31
#include "mg_.h"
/*--------------------------------------------------------------------------*/
static C_Comment   dummy_c_comment;
static Cxx_Comment dummy_cxx_comment;
/*--------------------------------------------------------------------------*/
void C_Comment::parse(CS& file)
{
  int here = file.cursor();
  for (;;) {
    file.skipto1('*');
    if (file.pmatch("*/")) {
      break;  // done with comment
    }else if (file.stuck(&here)) {untested();
      file.warn(0, "unterminated C comment");
      break;
    }else{untested();
      file.skip();
    }
  }
}
/*--------------------------------------------------------------------------*/
void Cxx_Comment::parse(CS& file)
{
  int here = file.cursor();
  file.skipto1('\n');
  if (file.stuck(&here)) {untested();
    file.warn(0, "unterminated C++ comment");
  }else{
  }
}
/*--------------------------------------------------------------------------*/
void Port_1::parse(CS& file)
{
  file >> _name;
  int here = file.cursor();
  for (;;) {
    ONE_OF
      || get(file, "short_to",	&_short_to)
      || get(file, "short_if",	&_short_if)
      ;
    if (file.skip1b(";")) {
      break;
    }else if (!file.more()) {untested();
      file.warn(0, "premature EOF (Port_1)");
      break;
    }else if (file.stuck(&here)) {
      break;
    }else{
    }
  }
}
/*--------------------------------------------------------------------------*/
void Head::parse(CS& file)
{
  int here = file.cursor();
  _begin = file.fullstring();
  for (;;) {
    file.skipto1('*');
    if (file.pmatch("*/")) {
      _end = file.tail();
      break;  // done with head
    }else if (file.stuck(&here)) {untested();
      file.warn(0, "unterminated head");
      break;
    }else{
      file.skip();
    }
  }
}
/*--------------------------------------------------------------------------*/
File::File(const std::string& file_name)
  :_name(file_name),
   _file(CS_FILE(), file_name)
{
  _file.set_exact();
  get(_file, "/*",		&_head);
  int here = _file.cursor();
  for (;;) {
    ONE_OF
      || get(_file, "/*",	 &dummy_c_comment)
      || get(_file, "//",	 &dummy_cxx_comment)
      || get(_file, "`",	 &dummy_cxx_comment)
      || get(_file, "h_headers", &_h_headers)
      || get(_file, "cc_headers",&_cc_headers)
      || get(_file, "device",	 &_device_list)
      || get(_file, "model", 	 &_model_list)
      || get(_file, "h_direct",  &_h_direct)
      || get(_file, "cc_direct", &_cc_direct)
      || get(_file, "nature",	 &_nature_list)
      || get(_file, "discipline",&_discipline_list)
      || get(_file, "module",	 &_module_list)
      || get(_file, "macromodule", &_module_list)
      ;
    if (!_file.more()) {
      break;
    }else if (_file.stuck(&here)) {itested();
      _file.warn(0, "syntax error, need head or model");
      break;
    }else{
    }
  }
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
